PROGRAM test_driver
USE fruit
USE log_messages_test
USE log_message_control_test
USE dense_matrix_test
USE vector_test
USE band_sym_matrix_test
USE linear_solver_test
USE material_data_test
USE field_data_test
USE boundary_data_test
USE constitutive_test
USE pde_solver_control_test


  CALL init_fruit

  ! log_messages message code tests
  CALL test_ALLOC_message_code
  CALL test_DIMEN_message_code
  CALL test_EXCEED_message_code
  CALL test_EXISTS_message_code
  CALL test_FORMT_message_code
  CALL test_POSDEF_message_code
  CALL test_POSIT_message_code
  CALL test_SZE_message_code
  CALL test_TYP_message_code
  CALL test_unexpected_message_code

  ! log_messages sender code tests
  CALL test_BFCRDR_sender_code
  CALL test_BNDDAT_sender_code
  CALL test_BNDRDR_sender_code
  CALL test_BSYMAT_sender_code
  CALL test_CNSMAT_sender_code
  CALL test_DMNRDR_sender_code
  CALL test_DNSMAT_sender_code
  CALL test_FLDDAT_sender_code
  CALL test_ICTRDR_sender_code
  CALL test_ICVRDR_sender_code
  CALL test_KBCRDR_sender_code
  CALL test_LINSLV_sender_code
  CALL test_MTLDAT_sender_code
  CALL test_MTLRDR_sender_code
  CALL test_NBCRDR_sender_code
  CALL test_TNSWTR_sender_code
  CALL test_VECTOR_sender_code
  CALL test_VECWTR_sender_code
  CALL test_unexpected_sender_code

  ! log_message_control tests
  CALL test_log_setFileName
  CALL test_log_initLogFile
  CALL test_log_closeLogFile
  CALL test_log_printLogMsg

  ! dense_matrix_def tests
  CALL test_dm_allocation_MSG
  CALL test_dm_allocation_SZE
  CALL test_dm_allocation_DAT
  CALL test_dm_deallocation
  CALL test_dm_num_rows_not_allocated
  CALL test_dm_num_rows_allocated
  CALL test_dm_num_cols_not_allocated
  CALL test_dm_num_cols_allocated
  CALL test_dm_get_POSIT
  CALL test_dm_get_VAL
  CALL test_dm_set_POSIT
  CALL test_dm_set_VAL
  CALL test_dm_add_DIMEN
  CALL test_dm_add_VAL
  CALL test_dm_add_OP
  CALL test_dm_scal_mul_VAL
  CALL test_dm_scal_mul_ZERO
  CALL test_dm_scal_mul_OP
  CALL test_dm_vec_mul_DIMEN
  CALL test_dm_vec_mul_VAL
  CALL test_dm_vec_mul_ZERO
  CALL test_dm_vec_mul_IDENT
  CALL test_dm_vec_mul_OP
  CALL test_dm_mat_mul_DIMEN
  CALL test_dm_mat_mul_VAL
  CALL test_dm_mat_mul_ZERO
  CALL test_dm_mat_mul_IDENT
  CALL test_dm_mat_mul_OP
  CALL test_dm_transpose

  ! vector_def tests
  CALL test_vec_allocation_MSG
  CALL test_vec_allocation_SZE
  CALL test_vec_allocation_DAT
  CALL test_vec_deallocation
  CALL test_vec_length_not_allocated
  CALL test_vec_length_allocated
  CALL test_vec_get_POSIT
  CALL test_vec_get_VAL
  CALL test_vec_set_POSIT
  CALL test_vec_set_VAL
  CALL test_vec_add_DIMEN
  CALL test_vec_add_VAL
  CALL test_vec_add_OP
  CALL test_vec_mapped_add_DIMEN
  CALL test_vec_mapped_add_POSIT
  CALL test_vec_mapped_add_VAL1
  CALL test_vec_mapped_add_VAL2
  CALL test_vec_mapped_add_VAL3
  CALL test_vec_scal_mul_VAL
  CALL test_vec_scal_mul_ZERO
  CALL test_vec_scal_mul_OP
  CALL test_vec_dot_prod_DIMEN
  CALL test_vec_dot_prod_ZERO
  CALL test_vec_dot_prod_VAL

  ! band_sym_matrix_def tests
  CALL test_bsm_allocation_MSG
  CALL test_bsm_allocation_SZE
  CALL test_bsm_allocation_DAT
  CALL test_bsm_deallocation
  CALL test_bsm_num_rows_not_allocated
  CALL test_bsm_num_rows_allocated
  CALL test_bsm_half_bw_not_allocated
  CALL test_bsm_half_bw_allocated
  CALL test_bsm_get_POSIT
  CALL test_bsm_get_VAL
  CALL test_bsm_set_POSIT
  CALL test_bsm_set_VAL
  CALL test_bsm_set_decomp_DIMEN
  CALL test_bsm_set_decomp_VAL
  CALL test_bsm_is_decomposed
  CALL test_bsm_add_DIMEN
  CALL test_bsm_add_VAL
  CALL test_bsm_add_OP
  CALL test_bsm_mapped_add_DIMEN1
  CALL test_bsm_mapped_add_DIMEN2
  CALL test_bsm_mapped_add_DIMEN3
  CALL test_bsm_mapped_add_POSIT1
  CALL test_bsm_mapped_add_POSIT2
  CALL test_bsm_mapped_add_VAL1
  CALL test_bsm_mapped_add_VAL2
  CALL test_bsm_mapped_add_VAL3
  CALL test_bsm_scal_mul_VAL
  CALL test_bsm_scal_mul_ZERO
  CALL test_bsm_scal_mul_OP
  CALL test_bsm_vec_mul_DIMEN
  CALL test_bsm_vec_mul_VAL
  CALL test_bsm_vec_mul_ZERO
  CALL test_bsm_vec_mul_IDENT
  CALL test_bsm_vec_mul_OP

  ! linear_solver tests
  CALL test_linear_solver_DIMEN
  CALL test_linear_solver_POSDEF
  CALL test_linear_solver_VAL
  CALL test_linear_solver_IDENT
  CALL test_linear_solver_ZERO
  CALL test_linear_solver_DECOMP

  ! material property data tests
  CALL test_mtl_allocation_MSG
  CALL test_mtl_allocation_SZE
  CALL test_mtl_num_mtl_not_allocated
  CALL test_mtl_num_mtl_allocated
  CALL test_mtl_get_emod_POSIT
  CALL test_mtl_set_emod_POSIT
  CALL test_mtl_set_emod_EXCEED
  CALL test_mtl_get_set_emod_VAL
  CALL test_mtl_get_pois_POSIT
  CALL test_mtl_set_pois_POSIT
  CALL test_mtl_set_pois_EXCEED
  CALL test_mtl_get_set_pois_VAL
  CALL test_mtl_get_dens_POSIT
  CALL test_mtl_set_dens_POSIT
  CALL test_mtl_set_dens_EXCEED
  CALL test_mtl_get_set_dens_VAL

  ! field data tests
  CALL test_fld_init_time_EXCEED
  CALL test_fld_time_step_not_initialized
  CALL test_fld_time_step_initialized
  CALL test_fld_num_time_step_not_initialized
  CALL test_fld_num_time_step_initialized
  CALL test_fld_node_allocation_MSG
  CALL test_fld_node_allocation_SZE
  CALL test_fld_num_node_not_allocated
  CALL test_fld_num_node_allocated
  CALL test_fld_get_coord_POSIT
  CALL test_fld_set_coord_POSIT
  CALL test_fld_set_coord_EXCEED
  CALL test_fld_get_set_coord_VAL
  CALL test_fld_get_fix_POSIT
  CALL test_fld_set_fix_POSIT
  CALL test_fld_get_set_fix_VAL
  CALL test_fld_dof_initialization_SZE
  CALL test_fld_num_dof_not_initialized
  CALL test_fld_num_dof_initialized
  CALL test_fld_get_dof_POSIT
  CALL test_fld_get_dof_VAL
  CALL test_fld_get_disp_POSIT
  CALL test_fld_set_disp_POSIT
  CALL test_fld_set_disp_EXCEED
  CALL test_fld_get_set_disp_VAL
  CALL test_fld_get_vel_POSIT
  CALL test_fld_set_vel_POSIT
  CALL test_fld_set_vel_EXCEED
  CALL test_fld_get_set_vel_VAL
  CALL test_fld_get_acc_POSIT
  CALL test_fld_set_acc_POSIT
  CALL test_fld_set_acc_EXCEED
  CALL test_fld_get_set_acc_VAL
  CALL test_fld_get_body_acc_POSIT
  CALL test_fld_set_body_acc_POSIT
  CALL test_fld_set_body_acc_EXCEED
  CALL test_fld_get_set_body_acc_VAL
  CALL test_fld_get_stress_node_POSIT
  CALL test_fld_set_stress_node_POSIT
  CALL test_fld_set_stress_node_EXCEED
  CALL test_fld_get_set_stress_node_VAL
  CALL test_fld_get_strain_node_POSIT
  CALL test_fld_set_strain_node_POSIT
  CALL test_fld_set_strain_node_EXCEED
  CALL test_fld_get_set_strain_node_VAL
  CALL test_fld_elem_allocation_MSG
  CALL test_fld_elem_allocation_SZE
  CALL test_fld_num_elem_not_allocated
  CALL test_fld_num_elem_allocated
  CALL test_fld_get_connect_POSIT
  CALL test_fld_set_connect_POSIT
  CALL test_fld_set_connect_EXCEED
  CALL test_fld_get_set_connect_VAL
  CALL test_fld_vol_elem_POSIT
  CALL test_fld_vol_elem_ZERO
  CALL test_fld_vol_elem_VAL
  CALL test_fld_get_stress_elem_POSIT
  CALL test_fld_set_stress_elem_POSIT
  CALL test_fld_set_stress_elem_EXCEED
  CALL test_fld_get_set_stress_elem_VAL
  CALL test_fld_get_strain_elem_POSIT
  CALL test_fld_set_strain_elem_POSIT
  CALL test_fld_set_strain_elem_EXCEED
  CALL test_fld_get_set_strain_elem_VAL

  ! boundary data tests
  CALL test_bnd_elem_allocation_MSG
  CALL test_bnd_elem_allocation_SZE
  CALL test_bnd_num_elem_not_allocated
  CALL test_bnd_num_elem_allocated
  CALL test_bnd_get_connect_POSIT
  CALL test_bnd_set_connect_POSIT
  CALL test_bnd_set_connect_EXCEED
  CALL test_bnd_get_set_connect_VAL
  CALL test_bnd_len_bound_elem_POSIT
  CALL test_bnd_len_bound_elem_ZERO
  CALL test_bnd_len_bound_elem_VAL
  CALL test_bnd_get_trac_POSIT
  CALL test_bnd_set_trac_POSIT
  CALL test_bnd_set_trac_EXCEED
  CALL test_bnd_get_set_trac_VAL

  ! constitutive matrix tests
  CALL test_constitutive_EXCEED
  CALL test_constitutive_ZERO
  CALL test_constitutive_VAL

  ! pde solver tests
  CALL test_pde_solver_initialization

  CALL fruit_summary

END PROGRAM test_driver
